<?php
/*##################################################
 *                                articles_contrib.php
 *                            -------------------
 *   begin              : October 22, 2009
 *   copyright          : (C) 2009 Roguelon Geoffrey, Nicolas ????
 *   email              : liaght@gmail.com
 *
 *
 ###################################################
 *
 *   This program is free software; you can redistribute it and/or modify
 *   it under the terms of the GNU General Public License as published by
 *   the Free Software Foundation; either version 2 of the License, or
 *   (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this program; if not, write to the Free Software
 * Foundation, Inc., 51 Franklin Street, Fifth Floor, Boston, MA  02110-1301, USA.
 *
###################################################*/

// Dfinition du titre.
define('TITLE', $CONTRIB_ARTICLES_LANG['contribution']);

// Chargement de la langue.
load_module_lang('articles');

// Fil d'ariane.
$Bread_crumb->add($CONTRIB_ARTICLES_LANG['articles'], url(PATH_TO_ROOT . '/articles/articles.php'));

// On inclut les classes dont nous avons besoin.
import('util/url');
import('util/date');
$now = new Date(DATE_NOW, TIMEZONE_AUTO);
import('util/mini_calendar');

// Dfinition des variables GET.
$id = retrieve(GET, 'id', 0, TINTEGER);

// Variable d'autorisation.
$auth_contribute = $User->check_auth($CONTRIBUTION['articles']['auth'], AUTH_CONTRIB_CONTRIBUTE);
$auth_write = $User->check_auth($CONTRIBUTION['articles']['auth'], AUTH_CONTRIB_WRITE);
$auth_moderate = $User->check_auth($CONTRIBUTION['articles']['auth'], AUTH_CONTRIB_MODERATE);

if (!empty($_GET['icon']))
{
	$ajax_result = second_parse_url(retrieve(GET, 'icon', '/articles/articles_mini.png', TSTRING));
}
elseif (!empty($_POST['submit']) || !empty($_POST['ajax']))
{
	$date = !empty($_POST['date']) ? MiniCalendar::retrieve_date('date') : $now;
	$date = $date->get_timestamp();

	if (!empty($_POST['start']))
	{
		$start = MiniCalendar::retrieve_date('start');
		$start = $start->get_timestamp();
	}

	if (!empty($_POST['end']))
	{
		$end = MiniCalendar::retrieve_date('end');
		$end = $end->get_timestamp();
	}

	$visible = retrieve(POST, 'visible', 0, TINTEGER);

	$articles = array(
		'id' => retrieve(POST, 'idedit', 0, TINTEGER),
		'title' => retrieve(POST, 'title', '', TSTRING),
		'idcat' => retrieve(POST, 'idcat', 0, TINTEGER),
		'contents' => retrieve(POST, 'contents', '', TSTRING_PARSE),
		'timestamp' => $date + retrieve(POST, 'date_hour', 0, TINTEGER) * 3600 + retrieve(POST, 'date_min', 0, TINTEGER) * 60,
		'start' => $visible == 2 && $start > 0 ? $start : 0,
		'end' => $visible == 2 && $end > 0 ? $end : 0,
		'visible' => $visible,
		'icon' => new Url(retrieve(POST, 'icon', '', TSTRING))
	);

	if ($articles['start'] > 0 && $articles['start'] < $now) // Vrification de la cohrence de la date start.
	{
		$articles['start'] = 0;
	}

	if ($articles['end'] > 0 && ($articles['end'] < $now || $articles['end'] < $articles['start'])) // Vrification de la cohrence de la date end.
	{
		$articles['end'] = 0;
	}

	if (empty($articles['title']))
	{
		$Errorh->handler('require_title', E_USER_REDIRECT);
	}

	if (empty($articles['contents']))
	{
		$Errorh->handler('require_text', E_USER_REDIRECT);
	}

	if(!empty($_POST['ajax']))
	{
		$preview = new Template('contribution/articles.tpl');

		$date = new Date(DATE_TIMESTAMP, TIMEZONE_AUTO, $articles['timestamp']);

		$preview->assign_vars(array(
			'C_AJAX' => true,
			'TITLE' => stripslashes(utf8_decode($articles['title'])),
			'AUTHOR_DATE' => sprintf($CONTRIB_ARTICLES_LANG['author_date'], $User->get_attribute('login'), $date->format(DATE_FORMAT_SHORT, TIMEZONE_AUTO)),
			'CONTENTS' => stripslashes(second_parse(utf8_decode($articles['contents']))),
			'L_PREVIEW' => $LANG['preview']
		));

		$ajax_result = $preview->parse(TEMPLATE_STRING_MODE);
	}
	elseif ($articles['id'] > 0 && in_array($articles['idcat'], $CONTRIBUTION['articles']['cats']) && ($auth_write || $auth_moderate))
	{
		$Sql->query_inject("UPDATE " . PREFIX . "articles SET idcat = '" . $articles['idcat'] . "', title = '" . $articles['title'] . "', contents = '" . $articles['contents'] . "', icon = '" . $articles['icon']->absolute() . "', visible = '" . $articles['visible'] . "', start = '" .  $articles['start'] . "', end = '" . $articles['end'] . "', timestamp = '" . $articles['timestamp'] . "'
		WHERE id = '" . $articles['id'] . "'", __LINE__, __FILE__);

		// Approbation des contributions.
		if ($articles['visible'])
		{
			import('events/contribution');
			import('events/contribution_service');

			$corresponding_contributions = ContributionService::find_by_criteria('articles', $articles['id']);
			if (count($corresponding_contributions) > 0)
			{
				$contribution = $corresponding_contributions[0];
				//The contribution is now processed
				$contribution->set_status(EVENT_STATUS_PROCESSED);
				//We save the contribution
				ContributionService::save_contribution($contribution);
			}
		}
	}
	elseif (in_array($articles['idcat'], $CONTRIBUTION['articles']['cats']) && ($auth_contribute || $auth_write))
	{
		$Sql->query_inject("INSERT INTO " . PREFIX . "articles (idcat, title, contents, icon, timestamp, visible, start, end, user_id, nbr_com) VALUES('" . $articles['idcat'] . "', '" . $articles['title'] . "', '" . $articles['contents'] . "', '" . $articles['icon']->absolute() . "', '" . $articles['timestamp'] . "', '" . $articles['visible'] . "', '" . $articles['start'] . "', '" . $articles['end'] . "', '" . $User->get_attribute('user_id') . "', '0')", __LINE__, __FILE__);

		$articles['id'] = $Sql->insert_id("SELECT MAX(id) FROM " . PREFIX . "articles");

		if (!$auth_write)
		{
			//Importing the contribution classes
			import('events/contribution');
			import('events/contribution_service');

			$contribution = new Contribution();
			//The id of the file in the module. It's useful when the module wants to search a contribution (we will need it in the file edition)
			$contribution->set_id_in_module($articles['id']);
			//The description of the contribution (the counterpart) to explain why did the contributor contributed
			$contribution->set_description(stripslashes(retrieve(POST, 'counterpart', '', TSTRING_PARSE)));
			//The entitled of the contribution
			$contribution->set_entitled(stripslashes(sprintf($CONTRIB_ARTICLES_LANG['contribution_entitled'], $articles['title'])));
			//The URL where a validator can treat the contribution (in the file edition panel)
			$contribution->set_fixing_url('/contribution/contribution.php?module=articles&id=' . $articles['id']);
			//Who is the contributor?
			$contribution->set_poster_id($User->get_attribute('user_id'));
			//The module
			$contribution->set_module('articles');
			//Assignation des autorisations d'criture / Writing authorization assignation
			$contribution->set_auth(
				//On dplace le bit sur l'autorisation obtenue pour le mettre sur celui sur lequel travaille les contributions,  savoir CONTRIBUTION_AUTH_BIT
				//We shift the authorization bit to the one with which the contribution class works, CONTRIBUTION_AUTH_BIT
				Authorizations::capture_and_shift_bit_auth(
					//On fusionne toutes les autorisations pour obtenir l'autorisation d'criture dans la catgorie slectionne :
					//C'est la fusion entre l'autorisation de la racine et de l'ensemble de la branche des catgories
					//We merge the whole authorizations of the branch constituted by the selected category
					$CONTRIBUTION['articles']['auth'],
					AUTH_CONTRIB_MODERATE, CONTRIBUTION_AUTH_BIT
				)
			);
			//Sending the contribution to the kernel. It will place it in the contribution panel to be approved
			ContributionService::save_contribution($contribution);
		}
	}
	else
	{
		$Errorh->handler('e_auth', E_USER_REDIRECT);
	}
}
else
{
	// On instancie les diffrentes classes.
	$tpl = new Template('contribution/articles.tpl');
	$start = new MiniCalendar('start');
	$end = new MiniCalendar('end');
	$date = new MiniCalendar('date');

	// Paramtre de style du calendrier.
	$end->set_style('margin-left:150px;');

	if ($id > 0)
	{
		$row = $Sql->query_array(PREFIX . 'articles', '*', "WHERE id = '" . $id . "'", __LINE__, __FILE__);

		// On vrifie l'existence de la articles.
		if (empty($row))
		{
			$Errorh->handler('unexist_articles_contribution', E_USER_REDIRECT);
		}
		elseif ((!$auth_write || $User->get_attribute('user_id') != $row['user_id']) && !$auth_moderate)
		{
			$Errorh->handler('e_auth', E_USER_REDIRECT);
		}

		// Fil d'ariane.
		$Bread_crumb->add($row['title'], PATH_TO_ROOT . '/articles/articles' . url('.php?id=' . $id, '-' . $row['idcat'] . '-' . $row['id'] . '-1.php'));
		$Bread_crumb->add($CONTRIB_ARTICLES_LANG['edit_articles'], url('contribution.php?module=articles&amp;id=' . $id, 'contribution-articles.php?id=' . $id));

		// Dfinition des diffrentes dates.
		$date_begin = new Date(DATE_TIMESTAMP, TIMEZONE_SYSTEM, $row['start']);
		$start->set_date($date_begin);
		$date_end = new Date(DATE_TIMESTAMP, TIMEZONE_SYSTEM, $row['end']);
		$end->set_date($date_end);
		$release = new Date(DATE_TIMESTAMP, TIMEZONE_SYSTEM, $row['timestamp']);
		$date->set_date($release);

		$row['icon'] = str_replace(HOST . DIR, '', $row['icon']);

		// Correction de la relativt des liens des articles.
		if (substr_count($row['icon'], '/') == 0) $row['icon'] = '/articles/' . $row['icon'];

		// Vrification de l'image.
		if (!empty($row['icon'])) $icon = new Url($row['icon']);

		// Variables du template.
		$tpl->assign_vars(array(
			'C_ICON' => !empty($row['icon']),
			'CONTENTS' => unparse($row['contents']),
			'IDEDIT' => $id,
			'ICON' => !empty($row['icon']) ? $row['icon'] : '',
			'ICON_PREVIEW' => !empty($row['icon']) ? $icon->absolute() : '',
			'NAME' => $row['title'],
			'DATE' => $date->display(),
			'DATE_HOUR' => $row['timestamp'] > 0 ? $release->get_hours() : '',
			'DATE_MIN' => $row['timestamp'] > 0 ? $release->get_minutes() : '',
			'START' => $start->display(),
			'END' => $end->display(),
			'VISIBLE_WAITING' => $row['visible'] == 2 ? 1 : 0,
			'VISIBLE_ENABLED' => $row['visible'] == 1 ? 1 : 0,
			'VISIBLE_UNAPROB' => $row['visible'] == 0 ? 1 : 0,
			'L_TITLE' => $CONTRIB_ARTICLES_LANG['edit_articles']
		));
	}
	else
	{
		if ($auth_contribute || $auth_write)
		{
			// Fil d'ariane.
			$Bread_crumb->add($CONTRIB_ARTICLES_LANG['add_articles'], url('contribution.php?module=articles', 'contribution-articles.php'));

			// Dfinition des diffrentes dates.
			$start->set_date($now);
			$end->set_date($now);
			$date->set_date($now);

			// Variables du template.
			$tpl->assign_vars(array(
				'C_ICON' => false,
				'CONTENTS' => '',
				'IDEDIT' => 0,
				'ICON' => '',
				'ICON_PREVIEW' => '',
				'NAME' => '',
				'DATE' => $date->display(),
				'DATE_HOUR' => $now->get_hours(),
				'DATE_MIN' => $now->get_minutes(),
				'START' => $start->display(),
				'END' => $end->display(),
				'VISIBLE_WAITING' => 0,
				'VISIBLE_ENABLED' => 1,
				'VISIBLE_UNAPROB' => 0,
				'L_TITLE' => $CONTRIB_ARTICLES_LANG['add_articles']
			));
		}
		else
		{
			$Errorh->handler('e_auth', E_USER_REDIRECT);
		}
	}

	$tpl->assign_vars(array(
		'C_CONTRIBUTION' => $id == 0 && !$auth_write,
		'C_CONTRIBUTION_JS' => $id == 0 && !$auth_write ? 'true' : 'false',
		'KERNEL_EDITOR' => display_editor(),
		'CONTRIBUTION_COUNTERPART_EDITOR' => display_editor('counterpart'),
		'L_ARTICLES_DATE' => $LANG['articles_date'],
		'L_CATEGORY' => $LANG['category'],
		'L_CONTRIBUTION_COUNTERPART' => $CONTRIB_LANG['contribution_counterpart'],
		'L_CONTRIBUTION_COUNTERPART_EXPLAIN' => $CONTRIB_LANG['contribution_counterpart_explain'],
		'L_CONTRIBUTION_LEGEND' => $LANG['contribution'],
		'L_DESC' => $LANG['content'],
		'L_EXPLAIN_PAGE' => $LANG['explain_page'],
		'L_ICON' => $CONTRIB_ARTICLES_LANG['icon'],
		'L_IMMEDIATE' => $CONTRIB_ARTICLES_LANG['immediate'],
		'L_NAME' => $LANG['title'],
		'L_NOTICE_CONTRIBUTION' => $CONTRIB_ARTICLES_LANG['notice_contribution'],
		'L_PAGE_PROMPT' => $LANG['page_prompt'],
		'L_PREVIEW' => $LANG['preview'],
		'L_RELEASE_DATE' => $CONTRIB_ARTICLES_LANG['release_date'],
		'L_REQUIRE_TITLE' => $LANG['require_title'],
		'L_REQUIRE_TEXT' => $LANG['require_text'],
		'L_REQUIRE' => $LANG['require'],
		'L_RESET' => $LANG['reset'],
		'L_SUBMIT' => $LANG['submit'],
		'L_UNAPROB' => $LANG['unaprob'],
		'L_UNIT_HOUR' => $LANG['unit_hour'],
		'L_UNTIL' => $LANG['until']
	));

	// Catgories.
	$CAT_ARTICLES = array();
	$CAT_ARTICLES['0'] = array('name' => $LANG['root'], 'level' => 0);
	$Cache->load('articles');

	foreach ($CAT_ARTICLES as $key => $array)
	{
		if ($array['level'] == 0)
		{
			$i = 1;
		}
		elseif ($level < $array['level'])
		{
			$i++;
		}

		$tpl->assign_block_vars('select', array(
			'ID' => $key,
			'NAME' => str_repeat("--", $i) . '&nbsp;' . $array['name'],
			'SELECTED' => isset($row['idcat']) && $key == $row['idcat'] ? 1 : 0
		));

		$level = $array['level'];
	}
}

if (!empty($_POST['ajax']) || !empty($_GET['icon']))
{
	define('NO_SESSION_LOCATION', true);
	require_once('../kernel/header_no_display.php');
	echo $ajax_result;
	require_once('../kernel/footer_no_display.php');
}
else
{
	require_once('../kernel/header.php');

	if (!empty($tpl) && is_object($tpl))
	{
		$tpl->parse();
	}
	elseif (!empty($_POST['submit']))
	{
		// Feeds Regeneration
		import('content/syndication/feed');
		Feed::clear_cache('articles');

		if ($articles['visible'] || !empty($_POST['idedit']) && $_POST['idedit'] > 0)
		{
			redirect_confirm('../articles/articles' . ($articles['visible'] ? '.php?id=' . $articles['id'] : '.php'), (!empty($_POST['idedit']) && $_POST['idedit'] > 0 ? $CONTRIB_ARTICLES_LANG['success_edited'] : $CONTRIB_ARTICLES_LANG['success_added']), 10);
		}
		else
		{
			redirect_confirm('../member/contribution_panel.php', $CONTRIB_LANG['contribution_success'], 10);
		}
	}

	require_once('../kernel/footer.php');
}

?>