<?php
/*##################################################
 *                                contribution.php
 *                            -------------------
 *   begin              : October 22, 2009
 *   copyright          : (C) 2009 Roguelon Geoffrey, Nicolas ????
 *   email              : liaght@gmail.com
 *
 *
 ###################################################
 *
 *   This program is free software; you can redistribute it and/or modify
 *   it under the terms of the GNU General Public License as published by
 *   the Free Software Foundation; either version 2 of the License, or
 *   (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this program; if not, write to the Free Software
 * Foundation, Inc., 51 Franklin Street, Fifth Floor, Boston, MA  02110-1301, USA.
 *
###################################################*/

require_once('../kernel/begin.php');
require_once('contribution_constant.php'); // Chargement des constantes.

// Chargement de la classe module.
import('modules/modules_discovery_service');
$modulesLoader = new ModulesDiscoveryService();
$available_modules = $modulesLoader->get_available_modules();

// Chargement de la langue.
load_module_lang('contribution');

// Chargement du cache.
$Cache->load('contribution');

// Rcupration du module demand.
$module = retrieve(REQUEST, 'module', '', TSTRING);

if (!empty($module)) // Si le module est dfini dans l'URL.
{
	import('io/filesystem/folder');
	$modules = array();
	$contribution_folder = new Folder('.');

	foreach($contribution_folder->get_files('`[a-z]_contrib.php`') as $value) // On recherche tous les modules grs par la contribution.
	{
		$name_module = str_replace('./', '', str_replace('_contrib.php', '', $value->path));

		if (!empty($available_modules[$name_module]) && is_object($available_modules[$name_module]))
		{
			$modules[] = $name_module;
		}
	}

	if (in_array($module, $modules))
	{
		$Bread_crumb->add($LANG['contribution'], url(PATH_TO_ROOT . '/member/contribution_panel.php'));

		require_once PATH_TO_ROOT . '/contribution/' . $module . '_contrib.php'; // On inclut le fichier qui s'occupera des actions.
	}
	else
	{
		$Errorh->handler('module_unmanaged_contribution', E_USER_REDIRECT);
	}
}
else // Sinon on redirige vers le panneau de contribution.
{
	redirect(url('/member/contribution_panel.php'));
}

?>