<?php
/*##################################################
 *                                news_contrib.php
 *                            -------------------
 *   begin              : October 22, 2009
 *   copyright          : (C) 2009 Roguelon Geoffrey, Nicolas ????
 *   email              : liaght@gmail.com
 *
 *
 ###################################################
 *
 *   This program is free software; you can redistribute it and/or modify
 *   it under the terms of the GNU General Public License as published by
 *   the Free Software Foundation; either version 2 of the License, or
 *   (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this program; if not, write to the Free Software
 * Foundation, Inc., 51 Franklin Street, Fifth Floor, Boston, MA  02110-1301, USA.
 *
###################################################*/

// Dfinition du titre.
define('TITLE', $CONTRIB_NEWS_LANG['contribution']);

// Chargement de la langue.
load_module_lang('news');

// Fil d'ariane.
$Bread_crumb->add($CONTRIB_NEWS_LANG['news'], url(PATH_TO_ROOT . '/news/news.php'));

// On inclut les classes dont nous avons besoin.
import('util/url');
import('util/date');
$now = new Date(DATE_NOW, TIMEZONE_AUTO);
import('util/mini_calendar');

// Dfinition des variables GET.
$id = retrieve(GET, 'id', 0, TINTEGER);

// Variable d'autorisation.
$auth_contribute = $User->check_auth($CONTRIBUTION['news']['auth'], AUTH_CONTRIB_CONTRIBUTE);
$auth_write = $User->check_auth($CONTRIBUTION['news']['auth'], AUTH_CONTRIB_WRITE);
$auth_moderate = $User->check_auth($CONTRIBUTION['news']['auth'], AUTH_CONTRIB_MODERATE);

if (!empty($_GET['img_url']))
{
	$ajax_result =  preg_replace('`\[img(?:=(top|middle|bottom))?\]((?:[./]+|(?:https?|ftps?)://(?:[a-z0-9-]+\.)*[a-z0-9-]+(?:\.[a-z]{2,4})?(?::[0-9]{1,5})?/?)[^,\n\r\t\f]+\.(jpg|jpeg|bmp|gif|png|tiff|svg))\[/img\]`iU', "$2", retrieve(GET, 'img_url', '/news/news.png', TSTRING));
}
elseif (!empty($_GET['img_preview']))
{
	$ajax_result = second_parse_url(retrieve(GET, 'img_preview', '/news/news.png', TSTRING));
}
elseif (!empty($_POST['submit']) || !empty($_POST['ajax']))
{
	$timestamp = !empty($_POST['news_date']) ? MiniCalendar::retrieve_date('news_date') : $now;
	$timestamp = $timestamp->get_timestamp();

	if (!empty($_POST['release_date_begin']))
	{
		$start = MiniCalendar::retrieve_date('release_date_begin');
		$start = $start->get_timestamp();
	}

	if (!empty($_POST['release_date_end']))
	{
		$end = MiniCalendar::retrieve_date('release_date_end');
		$end = $end->get_timestamp();
	}

	$id_news = retrieve(POST, 'idedit', 0, TINTEGER);
	$visible = retrieve(POST, 'visible', 0, TINTEGER);

	$news = array(
		'title' => retrieve(POST, 'title', '', TSTRING),
		'idcat' => retrieve(POST, 'idcat', 0, TINTEGER),
		'contents' => retrieve(POST, 'contents', '', TSTRING_PARSE),
		'extend_contents' => retrieve(POST, 'extend_contents', '', TSTRING_PARSE),
		'timestamp' => $timestamp + retrieve(POST, 'news_date_hour', 0, TINTEGER) * 3600 + retrieve(POST, 'news_date_min', 0, TINTEGER) * 60,
		'start' => $visible == 2 && $start > 0 ? ($start + retrieve(POST, 'release_hour_begin', 0, TINTEGER) * 3600 + retrieve(POST, 'release_min_begin', 0, TINTEGER) * 60) : 0,
		'end' => $visible == 2 && $end > 0 ? ($end + retrieve(POST, 'release_hour_end', 0, TINTEGER) * 3600 + retrieve(POST, 'release_min_end', 0, TINTEGER) * 60) : 0,
		'visible' => $visible > 0 ? 1 : 0,
		'img' => new Url(retrieve(POST, 'img', '', TSTRING)),
		'alt' => retrieve(POST, 'alt', '', TSTRING)
	);

	if ($news['start'] > 0 && $news['start'] < $now) // Vrification de la cohrence de la date start.
	{
		$news['start'] = 0;
	}

	if ($news['end'] > 0 && ($news['end'] < $now || $news['end'] < $news['start'])) // Vrification de la cohrence de la date end.
	{
		$news['end'] = 0;
	}

	if (empty($news['title']))
	{
		$Errorh->handler('require_title', E_USER_REDIRECT);
	}

	if (empty($news['idcat']))
	{
		$Errorh->handler('require_cat_contribution', E_USER_REDIRECT);
	}

	if (empty($news['contents']))
	{
		$Errorh->handler('require_text', E_USER_REDIRECT);
	}

	if(!empty($_POST['ajax']))
	{
		$preview = new Template('news/news.tpl');

		$Cache->load('news');

		$date = new Date(DATE_TIMESTAMP, TIMEZONE_AUTO, $news['timestamp']);

		$preview->assign_vars(array('C_NEWS_BLOCK' => true));

		$preview->assign_block_vars('news', array(
			'C_IMG' => !empty($news['img']),
			'C_ICON' => 0,
			'ID' => 0,
			'IDCAT' => $news['idcat'],
			'ICON' => '',
			'TITLE' => stripslashes(utf8_decode($news['title'])),
			'CONTENTS' => stripslashes(second_parse(utf8_decode($news['contents']))),
			'EXTEND_CONTENTS' => stripslashes(second_parse(utf8_decode($news['extend_contents']))) . '<br /><br />',
			'IMG' => second_parse_url($news['img']->relative()),
			'IMG_DESC' => $news['alt'],
			'PSEUDO' => '',
			'DATE' => $CONFIG_NEWS['display_date'] ? $LANG['on'] . ': ' . $date->format(DATE_FORMAT_SHORT, TIMEZONE_AUTO) : '',
			'U_COM' => '',
			'U_USER_ID' => '',
			'U_NEWS_LINK' => ''
		));

		$ajax_result = $preview->parse(TEMPLATE_STRING_MODE);
	}
	elseif ($id_news > 0 && in_array($news['idcat'], $CONTRIBUTION['news']['cats']) && ($auth_write || $auth_moderate))
	{
		$Sql->query_inject("UPDATE " . PREFIX . "news SET idcat = '" . $news['idcat'] . "', title = '" . $news['title'] . "', contents = '" . $news['contents'] . "', extend_contents = '" . $news['extend_contents'] . "', img = '" . $news['img']->relative() . "', alt = '" . $news['alt'] . "', visible = '" . $news['visible'] . "', start = '" .  $news['start'] . "', end = '" . $news['end'] . "', timestamp = '" . $news['timestamp'] . "'
		WHERE id = '" . $id_news . "'", __LINE__, __FILE__);

		// Approbation des contributions.
		if ($news['visible'])
		{
			import('events/contribution');
			import('events/contribution_service');

			$corresponding_contributions = ContributionService::find_by_criteria('news', $id_news);
			if (count($corresponding_contributions) > 0)
			{
				$contribution = $corresponding_contributions[0];
				//The contribution is now processed
				$contribution->set_status(EVENT_STATUS_PROCESSED);
				//We save the contribution
				ContributionService::save_contribution($contribution);
			}
		}
	}
	elseif (in_array($news['idcat'], $CONTRIBUTION['news']['cats']) && ($auth_contribute || $auth_write))
	{
		$Sql->query_inject("INSERT INTO " . PREFIX . "news (idcat, title, contents, extend_contents, timestamp, visible, start, end, user_id, img, alt, nbr_com) VALUES('" . $news['idcat'] . "', '" . $news['title'] . "', '" . $news['contents'] . "', '" . $news['extend_contents'] . "', '" . $news['timestamp'] . "', '" . $news['visible'] . "', '" . $news['start'] . "', '" . $news['end'] . "', '" . $User->get_attribute('user_id') . "', '" . $news['img']->relative() . "', '" . $news['alt'] . "', '0')", __LINE__, __FILE__);

		$id_news = $Sql->insert_id("SELECT MAX(id) FROM " . PREFIX . "news");

		if (!$auth_write)
		{
			//Importing the contribution classes
			import('events/contribution');
			import('events/contribution_service');

			$contribution = new Contribution();
			//The id of the file in the module. It's useful when the module wants to search a contribution (we will need it in the file edition)
			$contribution->set_id_in_module($id_news);
			//The description of the contribution (the counterpart) to explain why did the contributor contributed
			$contribution->set_description(stripslashes(retrieve(POST, 'counterpart', '', TSTRING_PARSE)));
			//The entitled of the contribution
			$contribution->set_entitled(stripslashes(sprintf($CONTRIB_NEWS_LANG['contribution_entitled'], $news['title'])));
			//The URL where a validator can treat the contribution (in the file edition panel)
			$contribution->set_fixing_url('/contribution/contribution.php?module=news&id=' . $id_news);
			//Who is the contributor?
			$contribution->set_poster_id($User->get_attribute('user_id'));
			//The module
			$contribution->set_module('news');
			//Assignation des autorisations d'criture / Writing authorization assignation
			$contribution->set_auth(
				//On dplace le bit sur l'autorisation obtenue pour le mettre sur celui sur lequel travaille les contributions,  savoir CONTRIBUTION_AUTH_BIT
				//We shift the authorization bit to the one with which the contribution class works, CONTRIBUTION_AUTH_BIT
				Authorizations::capture_and_shift_bit_auth(
					//On fusionne toutes les autorisations pour obtenir l'autorisation d'criture dans la catgorie slectionne :
					//C'est la fusion entre l'autorisation de la racine et de l'ensemble de la branche des catgories
					//We merge the whole authorizations of the branch constituted by the selected category
					$CONTRIBUTION['news']['auth'],
					AUTH_CONTRIB_MODERATE, CONTRIBUTION_AUTH_BIT
				)
			);
			//Sending the contribution to the kernel. It will place it in the contribution panel to be approved
			ContributionService::save_contribution($contribution);
		}
	}
	else
	{
		$Errorh->handler('e_auth', E_USER_REDIRECT);
	}
}
else
{
	// On instancie les diffrentes classes.
	$tpl = new Template('contribution/news.tpl');
	$release_date_begin = new MiniCalendar('release_date_begin');
	$release_date_end = new MiniCalendar('release_date_end');
	$news_date = new MiniCalendar('news_date');

	// Paramtre de style du calendrier.
	$release_date_end->set_style('margin-left:150px;');

	if ($id > 0)
	{
		$row = $Sql->query_array(PREFIX . 'news', '*', "WHERE id = '" . $id . "'", __LINE__, __FILE__);

		// On vrifie l'existence de la news.
		if (empty($row))
		{
			$Errorh->handler('unexist_news_contribution', E_USER_REDIRECT);
		}
		elseif ((!$auth_write || $User->get_attribute('user_id') != $row['user_id']) && !$auth_moderate)
		{
			$Errorh->handler('e_auth', E_USER_REDIRECT);
		}

		// Fil d'ariane.
		$Bread_crumb->add($row['title'], PATH_TO_ROOT . '/news/news' . url('.php?id=' . $id, '-' . 0 . '-' . $row['id'] . '+' . url_encode_rewrite($row['title']) . '.php'));
		$Bread_crumb->add($CONTRIB_NEWS_LANG['edit_news'], url('contribution.php?module=news&amp;id=' . $id, 'contribution-news.php?id=' . $id));

		// Dfinition des diffrentes dates.
		$date_begin = new Date(DATE_TIMESTAMP, TIMEZONE_SYSTEM, $row['start']);
		$release_date_begin->set_date($date_begin);
		$date_end = new Date(DATE_TIMESTAMP, TIMEZONE_SYSTEM, $row['end']);
		$release_date_end->set_date($date_end);
		$date = new Date(DATE_TIMESTAMP, TIMEZONE_SYSTEM, $row['timestamp']);
		$news_date->set_date($date);

		// Vrification de l'image.
		if (!empty($row['img'])) $img_url = new Url($row['img']);

		// Variables du template.
		$tpl->assign_vars(array(
			'ALT' => $row['alt'],
			'CONTENTS' => unparse($row['contents']),
			'EXTEND_CONTENTS' => unparse($row['extend_contents']),
			'IDEDIT' => $id,
			'IMG' => !empty($row['img']),
			'IMG_PREVIEW' => !empty($row['img']) ? $img_url->absolute() : '',
			'NAME' => $row['title'],
			'NEWS_DATE' => $news_date->display(),
			'NEWS_DATE_HOUR' => $row['timestamp'] > 0 ? $date->get_hours() : '',
			'NEWS_DATE_MIN' => $row['timestamp'] > 0 ? $date->get_minutes() : '',
			'RELEASE_DATE_BEGIN' => $release_date_begin->display(),
			'RELEASE_DATE_END' => $release_date_end->display(),
			'RELEASE_HOUR_BEGIN' => $row['start'] > 0 ? $date_begin->get_hours() : '',
			'RELEASE_HOUR_END' => $row['end'] > 0 ? $date_end->get_hours() : '',
			'RELEASE_MIN_BEGIN' => $row['start'] > 0 ? $date_begin->get_minutes() : '',
			'RELEASE_MIN_END' => $row['end'] > 0 ? $date_end->get_minutes() : '',
			'VISIBLE_WAITING' => $row['visible'] == 1 && ($row['start'] > 0 || $row['end'] > 0) ? 1 : 0,
			'VISIBLE_ENABLED' => $row['visible'] == 1 && $row['start'] == 0 && $row['end'] == 0 ? 1 : 0,
			'VISIBLE_UNAPROB' => $row['visible'] == 0 ? 1 : 0,
			'L_TITLE' => $LANG['edit_news']
		));
	}
	else
	{
		if ($auth_contribute || $auth_write)
		{
			// Fil d'ariane.
			$Bread_crumb->add($CONTRIB_NEWS_LANG['add_news'], url('contribution.php?module=news', 'contribution-news.php'));

			// Dfinition des diffrentes dates.
			$release_date_begin->set_date($now);
			$release_date_end->set_date($now);
			$news_date->set_date($now);

			// Variables du template.
			$tpl->assign_vars(array(
				'ALT' => '',
				'CONTENTS' => '',
				'EXTEND_CONTENTS' => '',
				'IDEDIT' => 0,
				'IMG' => '',
				'IMG_PREVIEW' => '',
				'NAME' => '',
				'NEWS_DATE' => $news_date->display(),
				'NEWS_DATE_HOUR' => $now->get_hours(),
				'NEWS_DATE_MIN' => $now->get_minutes(),
				'RELEASE_DATE_BEGIN' => $release_date_begin->display(),
				'RELEASE_DATE_END' => $release_date_end->display(),
				'RELEASE_HOUR_BEGIN' => '',
				'RELEASE_HOUR_END' => '',
				'RELEASE_MIN_BEGIN' => '',
				'RELEASE_MIN_END' => '',
				'VISIBLE_WAITING' => 0,
				'VISIBLE_ENABLED' => 1,
				'VISIBLE_UNAPROB' => 0,
				'L_TITLE' => $LANG['add_news']
			));
		}
		else
		{
			$Errorh->handler('e_auth', E_USER_REDIRECT);
		}
	}

	$tpl->assign_vars(array(
		'C_CONTRIBUTION' => $id == 0 && !$auth_write,
		'C_CONTRIBUTION_JS' => $id == 0 && !$auth_write ? 'true' : 'false',
		'KERNEL_EDITOR' => display_editor(),
		'KERNEL_EDITOR_EXTEND' => display_editor('extend_contents'),
		'CONTRIBUTION_COUNTERPART_EDITOR' => display_editor('counterpart'),
		'L_AT' => $LANG['at'],
		'L_CATEGORY' => $LANG['category'],
		'L_CONTRIBUTION_COUNTERPART' => $CONTRIB_LANG['contribution_counterpart'],
		'L_CONTRIBUTION_COUNTERPART_EXPLAIN' => $CONTRIB_LANG['contribution_counterpart_explain'],
		'L_CONTRIBUTION_LEGEND' => $LANG['contribution'],
		'L_DESC' => $LANG['content'],
		'L_DESC_EXTENDED' => $LANG['extended_news'],
		'L_IMG_DESC' => $LANG['img_desc'],
		'L_IMG_LINK' => $LANG['img_link'],
		'L_IMG_MANAGEMENT' => $LANG['img_management'],
		'L_IMMEDIATE' => $CONTRIB_NEWS_LANG['immediate'],
		'L_NAME' => $LANG['title'],
		'L_NEWS_DATE' => $LANG['news_date'],
		'L_NO_IMG' => $LANG['no_img'],
		'L_NOTICE_CONTRIBUTION' => $CONTRIB_NEWS_LANG['notice_contribution'],
		'L_PREVIEW' => $LANG['preview'],
		'L_PREVIEW_IMG' => $LANG['preview_image'],
		'L_PREVIEW_IMG_EXPLAIN' => $LANG['preview_image_explain'],
		'L_RELEASE_DATE' => $CONTRIB_NEWS_LANG['release_date'],
		'L_REQUIRE_TITLE' => $LANG['require_title'],
		'L_REQUIRE_CAT' => $CONTRIB_LANG['require_cat'],
		'L_REQUIRE_TEXT' => $LANG['require_text'],
		'L_REQUIRE' => $LANG['require'],
		'L_RESET' => $LANG['reset'],
		'L_SUBMIT' => $LANG['submit'],
		'L_UNAPROB' => $LANG['unaprob'],
		'L_UNIT_HOUR' => $LANG['unit_hour'],
		'L_UNTIL' => $LANG['until']
	));

	// Catgories.
	$i = 0;
	$result = $Sql->query_while("SELECT id, name FROM " . PREFIX . "news_cat", __LINE__, __FILE__);
	while ($cat = $Sql->fetch_assoc($result))
	{
		if (in_array($cat['id'], $CONTRIBUTION['news']['cats']))
		{
			$tpl->assign_block_vars('select', array(
				'ID' => $cat['id'],
				'NAME' => $cat['name'],
				'SELECTED' => isset($row['idcat']) && $cat['id'] == $row['idcat'] ? 1 : 0
			));

			$i++;
		}
	}
	$Sql->query_close($result);

	if ($i == 0)
	{
		$Errorh->handler('require_cat_create_contribution', E_USER_REDIRECT);
	}
}

if (!empty($_POST['ajax']) || !empty($_GET['img_url']) || !empty($_GET['img_preview']))
{
	define('NO_SESSION_LOCATION', true);
	require_once('../kernel/header_no_display.php');
	echo $ajax_result;
	require_once('../kernel/footer_no_display.php');
}
else
{
	require_once('../kernel/header.php');

	if (!empty($tpl) && is_object($tpl))
	{
		$tpl->parse();
	}
	elseif (!empty($_POST['submit']))
	{
		// Feeds Regeneration
		import('content/syndication/feed');
		Feed::clear_cache('news');

		if ($news['visible'] || !empty($_POST['idedit']) && $_POST['idedit'] > 0)
		{
			redirect_confirm('../news/news' . ($news['visible'] ? '.php?id=' . $id_news : '.php'), (!empty($_POST['idedit']) && $_POST['idedit'] > 0 ? $CONTRIB_NEWS_LANG['success_edited'] : $CONTRIB_NEWS_LANG['success_added']), 10);
		}
		else
		{
			redirect_confirm('../member/contribution_panel.php', $CONTRIB_LANG['contribution_success'], 10);
		}
	}

	require_once('../kernel/footer.php');
}

?>