<?php
/*##################################################
 *                                web_contrib.php
 *                            -------------------
 *   begin              : October 22, 2009
 *   copyright          : (C) 2009 Roguelon Geoffrey, Nicolas ????
 *   email              : liaght@gmail.com
 *
 *
 ###################################################
 *
 *   This program is free software; you can redistribute it and/or modify
 *   it under the terms of the GNU General Public License as published by
 *   the Free Software Foundation; either version 2 of the License, or
 *   (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this program; if not, write to the Free Software
 * Foundation, Inc., 51 Franklin Street, Fifth Floor, Boston, MA  02110-1301, USA.
 *
###################################################*/

// Dfinition du titre.
define('TITLE', $CONTRIB_WEB_LANG['contribution']);

// Chargement de la langue.
load_module_lang('web');

// Fil d'ariane.
$Bread_crumb->add($CONTRIB_WEB_LANG['web'], url(PATH_TO_ROOT . '/web/web.php'));

// On inclut les classes dont nous avons besoin.
import('util/date');

// Dfinition des variables GET.
$id = retrieve(GET, 'id', 0, TINTEGER);

// Variable d'autorisation.
$auth_contribute = $User->check_auth($CONTRIBUTION['web']['auth'], AUTH_CONTRIB_CONTRIBUTE);
$auth_write = $User->check_auth($CONTRIBUTION['web']['auth'], AUTH_CONTRIB_WRITE);
$auth_moderate = $User->check_auth($CONTRIBUTION['web']['auth'], AUTH_CONTRIB_MODERATE);

if (!empty($_POST['submit']))
{
	$web = array(
		'id' => retrieve(POST, 'id', 0, TINTEGER),
		'idcat' => retrieve(POST, 'idcat', 0, TINTEGER),
		'title' => retrieve(POST, 'title', '', TSTRING),
		'contents' => retrieve(POST, 'contents', '', TSTRING_PARSE),
		'url' => retrieve(POST, 'url', '', TSTRING_UNCHANGE),
		'counter' => retrieve(POST, 'counter', 0, TINTEGER),
		'timestamp' => new Date(DATE_NOW, TIMEZONE_AUTO),
		'visible' => $visible = retrieve(POST, 'aprob', 0, TBOOL)
	);

	if (empty($web['title']))
	{
		$Errorh->handler('require_title', E_USER_REDIRECT);
	}

	if (empty($web['idcat']))
	{
		$Errorh->handler('require_cat_contribution', E_USER_REDIRECT);
	}

	if (empty($web['url']))
	{
		$Errorh->handler('require_url', E_USER_REDIRECT);
	}

	if ($web['id'] > 0 && in_array($web['idcat'], $CONTRIBUTION['web']['cats']) && ($auth_write || $auth_moderate))
	{
		$Sql->query_inject("UPDATE " . PREFIX . "web SET idcat = '" . $web['idcat'] . "', title = '" . $web['title'] . "', contents = '" . $web['contents'] . "', url = '" . $web['url'] . "', aprob = '" . $web['visible'] . "', compt = '" . $web['counter'] . "', timestamp = '" . $web['timestamp']->get_timestamp() . "'	WHERE id = '" . $web['id'] . "'", __LINE__, __FILE__);

		// Approbation des contributions.
		if ($web['visible'])
		{
			import('events/contribution');
			import('events/contribution_service');

			$corresponding_contributions = ContributionService::find_by_criteria('web', $web['id']);
			if (count($corresponding_contributions) > 0)
			{
				$contribution = $corresponding_contributions[0];
				//The contribution is now processed
				$contribution->set_status(EVENT_STATUS_PROCESSED);
				//We save the contribution
				ContributionService::save_contribution($contribution);
			}
		}
	}
	elseif (in_array($web['idcat'], $CONTRIBUTION['web']['cats']) && ($auth_contribute || $auth_write))
	{
		$Sql->query_inject("INSERT INTO " . PREFIX . "web (idcat, title, contents, url, timestamp, aprob, compt, nbr_com) VALUES('" . $web['idcat'] . "', '" . $web['title'] . "', '" . $web['contents'] . "', '" . $web['url'] . "', '" . $web['timestamp']->get_timestamp() . "', '" . $web['visible'] . "', '" . $web['counter'] . "', '0')", __LINE__, __FILE__);

		$web['id'] = $Sql->insert_id("SELECT MAX(id) FROM " . PREFIX . "web");

		if (!$auth_write)
		{
			//Importing the contribution classes
			import('events/contribution');
			import('events/contribution_service');

			$contribution = new Contribution();
			//The id of the file in the module. It's useful when the module wants to search a contribution (we will need it in the file edition)
			$contribution->set_id_in_module($web['id']);
			//The description of the contribution (the counterpart) to explain why did the contributor contributed
			$contribution->set_description(stripslashes(retrieve(POST, 'counterpart', '', TSTRING_PARSE)));
			//The entitled of the contribution
			$contribution->set_entitled(stripslashes(sprintf($CONTRIB_WEB_LANG['contribution_entitled'], $web['title'])));
			//The URL where a validator can treat the contribution (in the file edition panel)
			$contribution->set_fixing_url('/contribution/contribution.php?module=web&id=' . $web['id']);
			//Who is the contributor?
			$contribution->set_poster_id($User->get_attribute('user_id'));
			//The module
			$contribution->set_module('web');
			//Assignation des autorisations d'criture / Writing authorization assignation
			$contribution->set_auth(
				//On dplace le bit sur l'autorisation obtenue pour le mettre sur celui sur lequel travaille les contributions,  savoir CONTRIBUTION_AUTH_BIT
				//We shift the authorization bit to the one with which the contribution class works, CONTRIBUTION_AUTH_BIT
				Authorizations::capture_and_shift_bit_auth(
					//On fusionne toutes les autorisations pour obtenir l'autorisation d'criture dans la catgorie slectionne :
					//C'est la fusion entre l'autorisation de la racine et de l'ensemble de la branche des catgories
					//We merge the whole authorizations of the branch constituted by the selected category
					$CONTRIBUTION['web']['auth'],
					AUTH_CONTRIB_MODERATE, CONTRIBUTION_AUTH_BIT
				)
			);
			//Sending the contribution to the kernel. It will place it in the contribution panel to be approved
			ContributionService::save_contribution($contribution);
		}
	}
	else
	{
		$Errorh->handler('e_auth', E_USER_REDIRECT);
	}
}
else
{
	// On instancie les diffrentes classes.
	$tpl = new Template('contribution/web.tpl');

	if ($id > 0)
	{
		$row = $Sql->query_array(PREFIX . 'web', '*', "WHERE id = '" . $id . "'", __LINE__, __FILE__);

		// On vrifie l'existence de la news.
		if (empty($row))
		{
			$Errorh->handler('unexist_web_contribution', E_USER_REDIRECT);
		}
		elseif (!$auth_write && !$auth_moderate)
		{
			$Errorh->handler('e_auth', E_USER_REDIRECT);
		}

		// Fil d'ariane.
		$Bread_crumb->add($row['title'], PATH_TO_ROOT . '/web/web' . url('.php?cat=' . $row['idcat'] . '&id=' . $id, '-' . $row['idcat'] . '-' . $row['id'] . '.php'));
		$Bread_crumb->add($CONTRIB_WEB_LANG['edit_web'], url('contribution.php?module=web&amp;id=' . $id, 'contribution-web.php?id=' . $id));

		// Variables du template.
		$tpl->assign_vars(array(
			'APROB' => $row['aprob'] ? true : false,
			'CONTENTS' => unparse($row['contents']),
			'COUNTER' => $row['compt'],
			'IDEDIT' => $id,
			'NAME' => $row['title'],
			'URL' => $row['url'],
			'L_TITLE' => $CONTRIB_WEB_LANG['edit_web']
		));
	}
	else
	{
		if ($auth_contribute || $auth_write)
		{
			// Fil d'ariane.
			$Bread_crumb->add($CONTRIB_WEB_LANG['add_web'], url('contribution.php?module=web', 'contribution-web.php'));

			// Variables du template.
			$tpl->assign_vars(array(
				'APROB' => true,
				'CONTENTS' => '',
				'COUNTER' => '0',
				'IDEDIT' => 0,
				'NAME' => '',
				'URL' => '',
				'L_TITLE' => $CONTRIB_WEB_LANG['add_web']
			));
		}
		else
		{
			$Errorh->handler('e_auth', E_USER_REDIRECT);
		}
	}

	$tpl->assign_vars(array(
		'C_CONTRIBUTION' => $id == 0 && !$auth_write,
		'KERNEL_EDITOR' => display_editor(),
		'CONTRIBUTION_COUNTERPART_EDITOR' => display_editor('counterpart'),
		'L_APROB' => $CONTRIB_WEB_LANG['aprob'],
		'L_CATEGORY' => $LANG['category'],
		'L_CONTRIBUTION_COUNTERPART' => $CONTRIB_LANG['contribution_counterpart'],
		'L_CONTRIBUTION_COUNTERPART_EXPLAIN' => $CONTRIB_LANG['contribution_counterpart_explain'],
		'L_CONTRIBUTION_LEGEND' => $LANG['contribution'],
		'L_COUNTER' => $CONTRIB_WEB_LANG['counter'],
		'L_DESC' => $LANG['content'],
		'L_NAME' => $LANG['title'],
		'L_NO' => $LANG['no'],
		'L_NOTICE_CONTRIBUTION' => $CONTRIB_WEB_LANG['notice_contribution'],
		'L_PREVIEW' => $LANG['preview'],
		'L_REQUIRE_TITLE' => $LANG['require_title'],
		'L_REQUIRE_CAT' => $CONTRIB_LANG['require_cat'],
		'L_REQUIRE_URL' => $LANG['require_url'],
		'L_REQUIRE' => $LANG['require'],
		'L_RESET' => $LANG['reset'],
		'L_SUBMIT' => $LANG['submit'],
		'L_URL' => $CONTRIB_WEB_LANG['url'],
		'L_YES' => $LANG['yes'],
	));

	// Catgories.
	$i = 0;
	$result = $Sql->query_while("SELECT id, name FROM " . PREFIX . "web_cat", __LINE__, __FILE__);
	while ($cat = $Sql->fetch_assoc($result))
	{
		if (in_array($cat['id'], $CONTRIBUTION['web']['cats']))
		{
			$tpl->assign_block_vars('select', array(
				'ID' => $cat['id'],
				'NAME' => $cat['name'],
				'SELECTED' => isset($row['idcat']) && $cat['id'] == $row['idcat'] ? 1 : 0
			));

			$i++;
		}
	}
	$Sql->query_close($result);

	if ($i == 0)
	{
		$Errorh->handler('require_cat_create_contribution', E_USER_REDIRECT);
	}
}

require_once('../kernel/header.php');

if (!empty($tpl) && is_object($tpl))
{
	$tpl->parse();
}
elseif (!empty($_POST['submit']))
{
	// Feeds Regeneration
	import('content/syndication/feed');
	Feed::clear_cache('news');

	if ($web['visible'] || !empty($_POST['id']) && $_POST['id'] > 0)
	{
		redirect_confirm('../web/web' . ($web['visible'] ? '.php?id=' . $web['id'] : '.php'), (!empty($_POST['id']) && $_POST['id'] > 0 ? $CONTRIB_WEB_LANG['success_edited'] : $CONTRIB_WEB_LANG['success_added']), 10);
	}
	else
	{
		redirect_confirm('../member/contribution_panel.php', $CONTRIB_LANG['contribution_success'], 10);
	}
}

require_once('../kernel/footer.php');

?>